## mwrap 0.33

=== example/Makefile ===
all:
	(cd foobar; make)
	(cd eventq; make)
	(cd eventq2; make)
	(cd zlib; make)
	(cd fem; make)

clean:
	(cd foobar; make clean)
	(cd eventq; make clean)
	(cd eventq2; make clean)
	(cd zlib; make clean)
	(cd fem; make clean)

=== src/Makefile ===
include ../make.inc


# === Primary targets ===

../mwrap: mwrap.o lex.yy.o mwrap-ast.o mwrap-typecheck.o \
	mwrap-mgen.o mwrap-cgen.o mwrap-ast.h
	$(CXX) -o ../mwrap mwrap.o mwrap-ast.o \
		mwrap-typecheck.o mwrap-mgen.o mwrap-cgen.o \
		lex.yy.o

mwrap.o: mwrap.cc lex.yy.c mwrap-ast.h
	$(CXX) -c mwrap.cc

mwrap.cc: mwrap.y
	$(BISON) -d -v mwrap.y -o mwrap.cc

lex.yy.o: lex.yy.c
	$(CC) -c lex.yy.c

lex.yy.c: mwrap.l
	$(FLEX) mwrap.l

mwrap-ast.o: mwrap-ast.cc mwrap-ast.h 
	$(CXX) -c -g mwrap-ast.cc

mwrap-typecheck.o: mwrap-typecheck.cc mwrap-ast.h
	$(CXX) -c -g mwrap-typecheck.cc

mwrap-cgen.o: mwrap-cgen.cc mwrap-ast.h mwrap-support.h
	$(CXX) -c -g mwrap-cgen.cc

mwrap-mgen.o: mwrap-mgen.cc mwrap-ast.h
	$(CXX) -c -g mwrap-mgen.cc

mwrap-support.h: mwrap-support.c stringify
	./stringify mex_header < mwrap-support.c > mwrap-support.h

stringify: stringify.c
	gcc -o stringify stringify.c


# === Clean-up targets ===

clean:
	rm -f mwrap.output
	rm -f *.o *~
	rm -f stringify

realclean: clean
	rm -f lex.yy.c mwrap.cc mwrap.hh mwrap-support.h mwrap.pdf

=== testing/Makefile ===
include ../make.inc

all: test_transfers test_cpp_complex $(TESTC99COMPLEX) test_syntax \
	test_typecheck test_catch test_fortran1 test_fortran2 \
	test_redirect test_include

test_transfers: 
	../mwrap -mex test_transfersmex \
		-c test_transfersmex.cc \
		-m test_transfers.m test_transfers.mw
	$(MEX) test_transfersmex.cc

test_cpp_complex: 
	../mwrap -cppcomplex \
		-mex test_cpp_complexmex \
		-c test_cpp_complexmex.cc \
		-m test_cpp_complex.m test_cpp_complex.mw
	$(MEX) test_cpp_complexmex.cc

test_c99_complex: 
	../mwrap -c99complex \
		-mex test_c99_complexmex \
		-c test_c99_complexmex.c \
		-m test_c99_complex.m test_c99_complex.mw
	$(MEX) test_c99_complexmex.c

test_syntax:
	- ../mwrap -cppcomplex test_syntax.mw >& test_syntax.log
	diff test_syntax.log test_syntax.ref

test_typecheck:
	- ../mwrap -cppcomplex test_typecheck.mw >& test_typecheck.log
	diff test_typecheck.log test_typecheck.ref

test_catch:
	../mwrap -mex test_catchmex -catch \
		-c test_catchmex.cc \
		-m test_catch.m \
		test_catch.mw
	$(MEX) test_catchmex.cc

test_fortran1:
	../mwrap -mex test_fortran1mex \
		-c test_fortran1mex.cc \
		-m test_fortran1.m \
		test_fortran1.mw
	$(MEX) test_fortran1mex.cc

test_fortran2:
	../mwrap -mex test_fortran2mex \
		-c test_fortran2mex.c \
		-m test_fortran2.m \
		test_fortran2.mw
	$(MEX) test_fortran2mex.c

test_redirect:
	../mwrap -mb test_redirect.mw 

test_include: 
	../mwrap -mex test_includemex\
		-c test_includemex.cc \
		-m test_include.m test_include.mw
	$(MEX) test_includemex.cc

clean:
	rm -f *~ *.mex* *.o* test_typecheck.log
	rm -f test_fortran1.m test_fortran2.m test_transfers.m test_catch.m
	rm -f test_cpp_complex.m test_c99_complex.m
	rm -f test_transfersmex.cc test_catchmex.cc test_fortranmex.cc
	rm -f test_cpp_complexmex.cc test_c99_complexmex.c 
	rm -f test_redirect.m test_redirect1.m

=== example/fem/interface/Makefile ===
include ../../../make.inc
MW=../../../mwrap

mex: wrap 
	$(MEX) -I../src femex.cc ../src/*.o
	mv femex.* *.m ../mwfem

wrap: 
	$(MW) -mex femex -c femex.cc \
		-mb assembler.mw mesh.mw elements.mw 

clean:
	rm -f *~

=== debian/changelog ===
mwrap (0.33-9build2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 Mar 2020 15:00:52 +0100

mwrap (0.33-9build1) focal; urgency=medium

  * Rebuild against new liboctave7.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 02 Nov 2019 20:38:01 +0100

mwrap (0.33-9) unstable; urgency=medium

  * Team upload

  * d/control:
    + Bump Standards-Version to 4.3.0 (no changes needed)
    + Bump to debhelper compat level 12
  * Build-depend on debhelper-compat instead of using d/compat

 -- Rafael Laboissiere <rafael@debian.org>  Wed, 02 Jan 2019 22:53:20 -0200

mwrap (0.33-8) unstable; urgency=medium

  * Team upload

  * d/p/force-doc-date.patch: New patch

 -- Rafael Laboissiere <rafael@debian.org>  Mon, 23 Jul 2018 16:48:02 -0300

mwrap (0.33-7) unstable; urgency=medium

  * Team upload

  * d/p/compile-with-gcc-8.patch: New patch (Closes: #897816)

 -- Rafael Laboissiere <rafael@debian.org>  Sun, 22 Jul 2018 08:50:56 -0300

mwrap (0.33-6) unstable; urgency=medium

  * Team upload

  * d/t/control: Add the necessary dependency to the binary package

 -- Rafael Laboissiere <rafael@debian.org>  Sun, 15 Jul 2018 05:07:08 -0300

mwrap (0.33-5) unstable; urgency=medium

  * Team upload

  * d/control:
    + Add Rules-Requires-Root: no
    + Bump Standards-Version to 4.1.5
  * New patches:
    + d/p/allow-alternate-mwrap-in-tests.patch
    + d/p/reproducible-build.patch
  * Add support for autopkgtest

 -- Rafael Laboissiere <rafael@debian.org>  Sat, 14 Jul 2018 16:25:45 -0300

mwrap (0.33-4) unstable; urgency=medium

  * Team upload

  * d/control: Bump Standards-Version to 4.1.3
  * d/control: Replace Priority:extra with Priority:optional.
    This is mandated by the Debian Policy since version 4.0.1.
  * Set debhelper compatibility level to >= 11
  * d/watch: Use secure upstream URI

 -- Rafael Laboissiere <rafael@debian.org>  Sun, 11 Feb 2018 08:42:44 -0200

mwrap (0.33-3) unstable; urgency=medium

  [ Sébastien Villemot ]
  * d/copyright: use secure URL for format.
  * d/watch: bump to format version 4.
  * d/control: use secure URLs for Vcs-* fields.

  [ Rafael Laboissiere ]
  * d/control:
     + Use Debian's GitLab URLs in Vcs-* headers
     + Change Maintainer to team+pkg-octave-team@tracker.debian.org

 -- Rafael Laboissiere <rafael@debian.org>  Thu, 08 Feb 2018 11:30:43 -0200

mwrap (0.33-2) unstable; urgency=medium

  * Team upload.
  * d/control, d/copyright: update upstream URL
  * Remove Thomas Weber and myself from Uploaders.
  * Remove obsolete DM-Upload-Allowed field.
  * Bump Standards-Version to 3.9.6, no changes needed.

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 18 Sep 2014 16:48:22 +0200

mwrap (0.33-1) unstable; urgency=low

  [ Nicolas Bourdaud ]
  * Initial release. (Closes: #673318)
  * Add Sébastien Villemot to uploaders list and enable DM-upload
  * Install examples

  [ Thomas Weber ]
  * Add Thomas Weber to Uploaders
  * Recommend 'octave' for the binary package

 -- Thomas Weber <tweber@debian.org>  Tue, 29 May 2012 00:14:33 +0200

=== debian/control ===
Source: mwrap
Section: devel
Priority: optional
Maintainer: Debian Octave Group <team+pkg-octave-team@tracker.debian.org>
Uploaders: Nicolas Bourdaud <nicolas.bourdaud@gmail.com>
Build-Depends: bison,
               debhelper-compat (= 12),
               flex,
               latexmk,
               liboctave-dev
Standards-Version: 4.3.0
Homepage: http://www.cs.cornell.edu/~bindel/sw/mwrap/
Vcs-Browser: https://salsa.debian.org/pkg-octave-team/mwrap
Vcs-Git: https://salsa.debian.org/pkg-octave-team/mwrap.git
Rules-Requires-Root: no

Package: mwrap
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: octave
Description: Octave/MATLAB mex generator
 MWrap is an interface generation system in the spirit of SWIG or matwrap.
 From a set of augmented Octave/MATLAB script files, MWrap will generate a
 MEX gateway to desired C/C++ function calls and Octave/MATLAB function
 files to access that gateway.  The details of converting to and from
 Octave/MATLAB's data structures, and of allocating and freeing temporary
 storage, are hidden from the user.

=== debian/tests/control ===
Tests: run
Depends: @, liboctave-dev
Restrictions: allow-stderr

=== debian/watch ===
version=4
https://www.cs.cornell.edu/~bindel/sw/mwrap/mwrap-([\d.]*).tar.gz

## mwrap 0.33.12

=== testing/Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 all: test_transfers test_cpp_complex $(TESTC99COMPLEX) test_syntax \
 	test_typecheck test_catch test_fortran1 test_fortran2 \
-	test_redirect test_include
+	test_redirect test_include test_single_cpp
 
 test_transfers: 
 	../mwrap -mex test_transfersmex \
@@ -25,11 +25,11 @@
 	$(MEX) test_c99_complexmex.c
 
 test_syntax:
-	- ../mwrap -cppcomplex test_syntax.mw >& test_syntax.log
+	- ../mwrap -cppcomplex test_syntax.mw 2> test_syntax.log
 	diff test_syntax.log test_syntax.ref
 
 test_typecheck:
-	- ../mwrap -cppcomplex test_typecheck.mw >& test_typecheck.log
+	- ../mwrap -cppcomplex test_typecheck.mw 2> test_typecheck.log 
 	diff test_typecheck.log test_typecheck.ref
 
 test_catch:
@@ -62,6 +62,18 @@
 		-m test_include.m test_include.mw
 	$(MEX) test_includemex.cc
 
+test_single_cpp: 
+	../mwrap -cppcomplex -mex test_single \
+		-c test_single.cc \
+		-mb test_single.mw
+	$(MEX) test_single.cc
+
+test_single_c99: 
+	../mwrap -c99complex -mex test_single \
+		-c test_single.c \
+		-mb test_single.mw
+	$(MEX) test_single.c
+
 clean:
 	rm -f *~ *.mex* *.o* test_typecheck.log
 	rm -f test_fortran1.m test_fortran2.m test_transfers.m test_catch.m
@@ -69,3 +81,6 @@
 	rm -f test_transfersmex.cc test_catchmex.cc test_fortranmex.cc
 	rm -f test_cpp_complexmex.cc test_c99_complexmex.c 
 	rm -f test_redirect.m test_redirect1.m
+	rm -f test_single.c test_single.cc
+	rm -f add.m addf.m addz.m addc.m 
+	rm -f arradd.m arraddf.m arraddz.m arraddc.m

=== debian/changelog ===
mwrap (0.33.12-1) unstable; urgency=medium

  * New upstream version 0.33.12
  * d/copyright: Reflect upstream changes
  * d/watch: Update for new upstream repository
  * d/u/metadata: Update upstream URLs
  * d/control:
    + Update upstream homepage
    + Add myself to the list of Uploaders
  * d/p/fix-makefile.patch: Drop patch (not needed anymore)
  * d/rules: Install mwrap executable
  * d/p/fix-build-error.patch: Drop patch (applied upstream)
  * Patches refreshed for new upstream version:
    + d/p/allow-alternate-mwrap-in-tests.patch
    + d/p/compile-with-gcc-8.patch
  * d/clean: Add mwrap.fls to the list of files to clean
  * d/p/reproducible-build.patch: Set Forwarded:not-needed
  * d/p/no-hardcoded-cc-cxx.patch: New patch
  * d/p/use-implicit-rules.patch: New patch
  * d/p/compile-with-gcc-8.patch: Add URL to Forwarded field
  * d/p/force-doc-date.patch: Set Forwarded:not-needed
  * d/p/compile-with-bison-3.6.1.patch: Update URL of Forwarded field
  * d/p/fix-doc-build.patch: Drop changes in doc/mwrap.tex
  * Add manual page through patch
    + d/p/man-page.patch: New patch
    + debian/mwrap.1: Remove file
    + debian/manpages: Install the file

 -- Rafael Laboissière <rafael@debian.org>  Wed, 05 Aug 2020 03:08:56 -0300

mwrap (0.33-10) unstable; urgency=medium

  * Team upload

  * d/u/metadata: New file
  * d/control:
    + Bump the Debhelper compatibility level to 13
    + Bump Standards-Version to 4.5.0 (no changes needed)
  * d/p/compile-with-bison-3.6.1.patch: New patch (Closes: #960402)

 -- Rafael Laboissière <rafael@debian.org>  Wed, 27 May 2020 09:23:45 -0300

## mwrap 1.0

=== src/Makefile ===
--- 
+++ 
@@ -37,7 +37,7 @@
 	./stringify mex_header < mwrap-support.c > mwrap-support.h
 
 stringify: stringify.c
-	gcc -o stringify stringify.c
+	$(CC) -o stringify stringify.c
 
 
 # === Clean-up targets ===

=== testing/Makefile ===
--- 
+++ 
@@ -3,6 +3,8 @@
 all: test_transfers test_cpp_complex $(TESTC99COMPLEX) test_syntax \
 	test_typecheck test_catch test_fortran1 test_fortran2 \
 	test_redirect test_include test_single_cpp
+# run the tests...
+	octave test_all.m
 
 test_transfers: 
 	../mwrap -mex test_transfersmex \
@@ -24,13 +26,17 @@
 		-m test_c99_complex.m test_c99_complex.mw
 	$(MEX) test_c99_complexmex.c
 
+# the following two are designed to create mwrap errors, and compared against
+# log files. For now, since they would break the make process, the minus signs
+# prevent them from being made.
 test_syntax:
 	- ../mwrap -cppcomplex test_syntax.mw 2> test_syntax.log
-	diff test_syntax.log test_syntax.ref
+	- diff test_syntax.log test_syntax.ref
 
 test_typecheck:
 	- ../mwrap -cppcomplex test_typecheck.mw 2> test_typecheck.log 
 	diff test_typecheck.log test_typecheck.ref
+
 
 test_catch:
 	../mwrap -mex test_catchmex -catch \
@@ -62,17 +68,18 @@
 		-m test_include.m test_include.mw
 	$(MEX) test_includemex.cc
 
+# these last two are tested by test_single.m ...
 test_single_cpp: 
-	../mwrap -cppcomplex -mex test_single \
-		-c test_single.cc \
+	../mwrap -cppcomplex -mex test_singlemex \
+		-c test_singlemex.cc \
 		-mb test_single.mw
-	$(MEX) test_single.cc
+	$(MEX) test_singlemex.cc
 
 test_single_c99: 
-	../mwrap -c99complex -mex test_single \
-		-c test_single.c \
+	../mwrap -c99complex -mex test_singlemex \
+		-c test_singlemex.c \
 		-mb test_single.mw
-	$(MEX) test_single.c
+	$(MEX) test_singlemex.c
 
 clean:
 	rm -f *~ *.mex* *.o* test_typecheck.log
@@ -81,6 +88,6 @@
 	rm -f test_transfersmex.cc test_catchmex.cc test_fortranmex.cc
 	rm -f test_cpp_complexmex.cc test_c99_complexmex.c 
 	rm -f test_redirect.m test_redirect1.m
-	rm -f test_single.c test_single.cc
+	rm -f test_singlemex.c test_singlemex.cc
 	rm -f add.m addf.m addz.m addc.m 
 	rm -f arradd.m arraddf.m arraddz.m arraddc.m

=== debian/changelog ===
mwrap (1.0-2) unstable; urgency=medium

  * d/p/avoid-seg-fault-fortran1.patch: New patch

 -- Rafael Laboissière <rafael@debian.org>  Sun, 09 Aug 2020 13:02:13 -0300

mwrap (1.0-1) unstable; urgency=medium

  * New upstream version 1.0
  * d/copyright: Reflect upstream changes
  * Patches refreshed for new upstream version:
    + d/p/fix-doc-build.patch
    + d/p/allow-alternate-mwrap-in-tests.patch
  * Dropped patches:
    + d/p/compile-with-gcc-8.patch
    + d/p/no-hardcoded-cc-cxx.patch
    + d/p/man-page.patch
  * d/p/use-octave-cli.patch: New patch

 -- Rafael Laboissière <rafael@debian.org>  Sat, 08 Aug 2020 11:31:45 -0300

=== debian/control ===
--- 
+++ 
@@ -2,14 +2,15 @@
 Section: devel
 Priority: optional
 Maintainer: Debian Octave Group <team+pkg-octave-team@tracker.debian.org>
-Uploaders: Nicolas Bourdaud <nicolas.bourdaud@gmail.com>
+Uploaders: Nicolas Bourdaud <nicolas.bourdaud@gmail.com>,
+           Rafael Laboissière <rafael@debian.org>
 Build-Depends: bison,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                flex,
                latexmk,
                liboctave-dev
-Standards-Version: 4.3.0
-Homepage: http://www.cs.cornell.edu/~bindel/sw/mwrap/
+Standards-Version: 4.5.0
+Homepage: https://www.cs.cornell.edu/~bindel/blurbs/mwrap.html
 Vcs-Browser: https://salsa.debian.org/pkg-octave-team/mwrap
 Vcs-Git: https://salsa.debian.org/pkg-octave-team/mwrap.git
 Rules-Requires-Root: no

=== debian/watch ===
version=4
opts="filenamemangle=s/(?:.*?)?v?([\.\d]+)\.tar\.gz/mwrap-$1.tar.gz/"	\
    https://github.com/zgimbutas/mwrap/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## mwrap 1.1

=== debian/changelog ===
mwrap (1.1-1) unstable; urgency=medium

  * New upstream version 1.1
  * d/copyright: Reflect upstream changes
  * Drop patches (applied upstream):
    + d/p/use-octave-cli.patch
    + d/p/avoid-seg-fault-fortran1.patch
  * Refresh patches for new upstream version:
    + d/p/force-doc-date.patch
    + d/p/allow-alternate-mwrap-in-tests.patch
  * d/watch: Drop option filenamemangle
  * d/control: Bump Standards-Version to 4.6.1 (no changes needed)

 -- Rafael Laboissière <rafael@debian.org>  Fri, 10 Jun 2022 07:42:53 -0300

mwrap (1.0-3) unstable; urgency=medium

  * d/p/avoid-seg-fault-fortran1.patch: Add URL to the Forwarded header
  * d/control: Bump Standards-Version to 4.6.0 (no changes needed)
  * d/copyright: Update copyright year for the debian/* files

 -- Rafael Laboissière <rafael@debian.org>  Sun, 21 Nov 2021 06:50:38 -0300

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
                flex,
                latexmk,
                liboctave-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Homepage: https://www.cs.cornell.edu/~bindel/blurbs/mwrap.html
 Vcs-Browser: https://salsa.debian.org/pkg-octave-team/mwrap
 Vcs-Git: https://salsa.debian.org/pkg-octave-team/mwrap.git

## mwrap 1.1.1

=== Makefile ===
include make.inc

bin:
	(cd src; make)

test: 
	(cd testing; make)

demo:
	(cd example; make)

clean:
	rm -f mwrap
	(cd src; make clean)
	(cd example; make clean)
	(cd testing; make clean)

realclean: clean
	(cd src; make realclean)

=== testing/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 	test_typecheck test_catch test_fortran1 test_fortran2 \
 	test_redirect test_include test_single_cpp
 # run the tests...
-	octave test_all.m
+	octave-cli --no-init-file --quiet test_all.m
 
 test_transfers: 
 	../mwrap -mex test_transfersmex \

=== example/foobar/Makefile ===
include ../../make.inc
MW=../../mwrap

all:
	$(MW) -mex fbmex -m foobar.m foobar.mw
	$(MW) -mex fbmex -c fbmex.c foobar.mw
	$(MEX) fbmex.c

clean:
	rm -f foobar.m fbmex.c fbmex.mex* *.o* *~

=== debian/changelog ===
mwrap (1.1.1-6) unstable; urgency=medium

  * d/p/deprecated-error-verbose-bison.patch: Add field Applied-Upstream
  * Adjust patches in order to avoid race conditions

 -- Rafael Laboissière <rafael@debian.org>  Mon, 17 Mar 2025 11:34:22 -0300

mwrap (1.1.1-5) unstable; urgency=medium

  * d/p/deprecated-error-verbose-bison.patch: Adjust patch for working
    with both versions 2 and 3 of Bison
  * d/rules: Remove file src/mwrap.y after dh_auto_clean

 -- Rafael Laboissière <rafael@debian.org>  Wed, 12 Mar 2025 04:44:31 -0300

mwrap (1.1.1-4) unstable; urgency=medium

  * d/p/avoid-race-condition-parallel-make.patch: New patch (Closes: #1092433)
  * d/p/deprecated-error-verbose-bison.patch: New patch
  * d/control: Bump Standards-Version to 4.7.2 (no changes needed)

 -- Rafael Laboissière <rafael@debian.org>  Sun, 09 Mar 2025 16:04:38 -0300

mwrap (1.1.1-3) unstable; urgency=medium

  [ Rafael Laboissière ]
  * d/control: Bump Standards-Version to 4.7.0 (no changes needed)

  [ Jeremy Bícha ]
  * Fix autopkgtests following dpkg changes (LP: #2071468)

 -- Rafael Laboissière <rafael@debian.org>  Mon, 01 Jul 2024 04:52:25 -0300

mwrap (1.1.1-2) unstable; urgency=medium

  * d/control: Bump Standards-Version to 4.6.2 (no changes needed)
  * d/copyright:
    + Update Source URL
    + Update years list for copyright of debian/* files
  * Use octave-dev instead of liboctave-dev

 -- Rafael Laboissière <rafael@debian.org>  Fri, 05 Jan 2024 07:42:26 -0300

mwrap (1.1.1-1) unstable; urgency=medium

  [ Rafael Laboissière ]
  * New upstream version 1.1.1

  [ Sébastien Villemot ]
  * Build-Depend on octave-dev instead of liboctave-dev

 -- Rafael Laboissière <rafael@debian.org>  Mon, 29 Aug 2022 04:24:37 -0300

=== debian/control ===
--- 
+++ 
@@ -8,8 +8,8 @@
                debhelper-compat (= 13),
                flex,
                latexmk,
-               liboctave-dev
-Standards-Version: 4.6.1
+               octave-dev
+Standards-Version: 4.7.2
 Homepage: https://www.cs.cornell.edu/~bindel/blurbs/mwrap.html
 Vcs-Browser: https://salsa.debian.org/pkg-octave-team/mwrap
 Vcs-Git: https://salsa.debian.org/pkg-octave-team/mwrap.git

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

%:
	dh  $@

execute_after_dh_auto_install:
	mkdir -p debian/mwrap/usr/bin
	install mwrap debian/mwrap/usr/bin

execute_after_dh_auto_clean:
	rm -f src/mwrap.y

## mwrap 1.2.1

=== Makefile ===
--- 
+++ 
@@ -2,6 +2,9 @@
 
 bin:
 	(cd src; make)
+
+doc:
+	(cd doc; make)
 
 test: 
 	(cd testing; make)

=== doc/Makefile ===
all: mwrap.pdf

mwrap.pdf: mwrap.tex
	pdflatex mwrap.tex

clean:
	rm -f mwrap.aux mwrap.log mwrap.pdf

=== src/Makefile ===
--- 
+++ 
@@ -12,10 +12,19 @@
 mwrap.o: mwrap.cc lex.yy.c mwrap-ast.h
 	$(CXX) -c mwrap.cc
 
-mwrap.cc: mwrap.y
+mwrap.cc mwrap.hh: mwrap.y
 	$(BISON) -d -v mwrap.y -o mwrap.cc
 
-lex.yy.o: lex.yy.c
+ifeq ($(shell bison --version 2>&1 | sed -n 's/^.*GNU Bison.* \([0-9]*\).*$$/\1/p'), 3)
+ERROR_VERBOSE = %define parse.error verbose
+else
+ERROR_VERBOSE = %error-verbose
+endif
+
+mwrap.y: mwrap.y.in
+	sed -e 's/@ERROR_VERBOSE@/$(ERROR_VERBOSE)/' < mwrap.y.in > mwrap.y
+
+lex.yy.o: lex.yy.c mwrap.hh
 	$(CC) -c lex.yy.c
 
 lex.yy.c: mwrap.l
@@ -48,5 +57,5 @@
 	rm -f stringify
 
 realclean: clean
-	rm -f lex.yy.c mwrap.cc mwrap.hh mwrap-support.h mwrap.pdf
+	rm -f mwrap.y lex.yy.c mwrap.cc mwrap.hh mwrap-support.h mwrap.pdf

=== testing/Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 all: test_transfers test_cpp_complex $(TESTC99COMPLEX) test_syntax \
 	test_typecheck test_catch test_fortran1 test_fortran2 \
-	test_redirect test_include test_single_cpp
+	test_redirect test_include test_single_cpp test_char_cpp
 # run the tests...
 	octave-cli --no-init-file --quiet test_all.m
 
@@ -68,6 +68,19 @@
 		-m test_include.m test_include.mw
 	$(MEX) test_includemex.cc
 
+# these two are tested by test_char.m ...
+test_char_cpp: 
+	../mwrap -cppcomplex -mex test_charmex \
+		-c test_charmex.cc \
+		-mb test_char.mw
+	$(MEX) test_charmex.cc
+
+test_char_c99: 
+	../mwrap -mex test_charmex \
+		-c test_charmex.c \
+		-mb test_char.mw
+	$(MEX) test_charmex.c
+
 # these last two are tested by test_single.m ...
 test_single_cpp: 
 	../mwrap -cppcomplex -mex test_singlemex \
@@ -81,6 +94,21 @@
 		-mb test_single.mw
 	$(MEX) test_singlemex.c
 
+test_gpu:
+	../mwrap -gpu -list -cppcomplex -mb -mex test_gpu -c test_gpu.cu test_gpu.mw
+
+test_gpu_complex:
+	../mwrap -gpu -list -cppcomplex -mb -mex test_gpu_complex -c test_gpu_complex.cu test_gpu_complex.mw
+
+test_gpu_int32:
+	../mwrap -gpu -list -cppcomplex -mb -mex test_gpu_int32 -c test_gpu_int32.cu test_gpu_int32.mw
+
+test_cpu:
+	../mwrap -list -cppcomplex -mb -mex test_cpu -c test_cpu.cc test_cpu.mw
+
+test_cpu_int32:
+	../mwrap -list -cppcomplex -mb -mex test_cpu_int32 -c test_cpu_int32.cc test_cpu_int32.mw
+
 clean:
 	rm -f *~ *.mex* *.o* test_typecheck.log
 	rm -f test_fortran1.m test_fortran2.m test_transfers.m test_catch.m
@@ -91,3 +119,5 @@
 	rm -f test_singlemex.c test_singlemex.cc
 	rm -f add.m addf.m addz.m addc.m 
 	rm -f arradd.m arraddf.m arraddz.m arraddc.m 
+	rm -f test_charmex.c test_charmex.cc
+	rm -f addchar.m arraddchar.m

=== example/eventq/Makefile ===
include ../../make.inc
MW=../../mwrap

all: pmex cmex hmex

pmex:
	$(MW) -mex eventqpmex -c eventqpmex.cc -mb eventq_plain.mw
	$(MEX) eventqpmex.cc

hmex:
	$(MW) -mex eventqhmex -c eventqhmex.cc -mb eventq_handle.mw
	$(MEX) eventqhmex.cc

cmex:
	mkdir -p \@eventq
	$(MW) -mex eventqcmex -c eventqcmex.cc -mb eventq_class.mw
	$(MEX) eventqcmex.cc

clean:
	rm -rf \@eventq/
	rm -f EventQ_*.m eventqh.m
	rm -f eventqcmex.* eventqpmex.* eventqhmex.* *.o *~

=== example/eventq2/Makefile ===
include ../../make.inc
MW=../../mwrap

mex:
	$(MW) -mex eventq2mex -c eventq2mex.cc -mb eventq2.mw
	$(MEX) eventq2mex.cc

clean:
	rm -f EventQ_*.m
	rm -f eventq2mex.* *.o *~

=== example/fem/Makefile ===
all:
	mkdir -p mwfem
	(cd src; make)
	(cd interface; make)

clean:
	(cd src; make clean)
	(cd interface; make clean)
	rm -rf mwfem

realclean: clean
	(cd src; make realclean)

=== example/zlib/Makefile ===
# See www.zlib.net
include ../../make.inc
MW=../../mwrap

gzmex:
	$(MW) -mex gzmex -mb gzfile.mw
	$(MW) -mex gzmex -c gzmex.c gzfile.mw
	$(MEX) gzmex.c -lz

clean:
	rm -f gz*.m gzmex.* *.o* eye.gz

=== example/fem/src/Makefile ===
# Targets for object files (we compile with MEX to avoid headaches
# about -fPIC and other flag compatibility issues)

include ../../../make.inc

OBJS= \
	assembler.o mesh.o \
	gauss2by2.o quad2d1.o \
	scalar1d.o scalar2d.o elastic2d1.o

all: $(OBJS)

.cc.o:
	$(MEX) -c $*.cc

elastic2d1.cc: 
	matexpr elastic2d.cc > elastic2d1.cc

quad2d1.cc:
	matexpr quad2d.cc > quad2d1.cc

clean:
	rm -f *.o *~

realclean:
	rm -f *.o elastic2d1.cc quad2d1.cc

=== debian/changelog ===
mwrap (1.2.1-3) unstable; urgency=medium

  * d/watch: Convert to format version 5
  * d/rules: Set DEB_BUILD_MAINT_OPTIONS to hardening=+all

 -- Rafael Laboissière <rafael@debian.org>  Sat, 18 Oct 2025 11:32:08 -0300

mwrap (1.2.1-2) unstable; urgency=medium

  * Upload to unstable
  * d/control: Drop “Rules-Requires-Root: no”, which is now the default

 -- Rafael Laboissière <rafael@debian.org>  Mon, 08 Sep 2025 06:35:55 -0300

mwrap (1.2.1-1) experimental; urgency=medium

  * New upstream version 1.2.1
  * d/p/fix-name-spelling.patch: Drop patch (applied upstream)
  * d/p/force-doc-date.patch: Refresh for new upstream version

 -- Rafael Laboissière <rafael@debian.org>  Tue, 06 May 2025 02:36:04 -0300

mwrap (1.2-1) experimental; urgency=medium

  * New upstream version 1.2
  * Use upstream Makefile for building the documentation
    + d/p/fix-doc-build.patch: Drop patch (applied upstream)
    + d/rules: Build and clean the documentation
    + d/docs: Fix path for the PDF file
    + d/clean: Drop obsolete lines
  * Refresh patches for new upstream version:
    + d/p/reproducible-build.patch
    + d/p/allow-alternate-mwrap-in-tests.patch
    + d/p/force-doc-date.patch
    + d/p/use-implicit-rules.patch
  * Drop patches (applied upstream):
    + d/p/avoid-race-condition-parallel-make.patch
    + d/p/deprecated-error-verbose-bison.patch
  * d/p/fix-name-spelling.patch: New patch
  * d/rules: Drop useless removal of src/mwrap.y

 -- Rafael Laboissière <rafael@debian.org>  Mon, 05 May 2025 16:12:04 -0300

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,6 @@
 Homepage: https://www.cs.cornell.edu/~bindel/blurbs/mwrap.html
 Vcs-Browser: https://salsa.debian.org/pkg-octave-team/mwrap
 Vcs-Git: https://salsa.debian.org/pkg-octave-team/mwrap.git
-Rules-Requires-Root: no
 
 Package: mwrap
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh  $@

execute_after_dh_auto_build:
	make -C doc

execute_after_dh_auto_install:
	mkdir -p debian/mwrap/usr/bin
	install mwrap debian/mwrap/usr/bin

execute_after_dh_auto_clean:
	make -C doc clean

=== debian/tests/control ===
Tests: run
Depends: @, octave-dev
Restrictions: allow-stderr

=== debian/watch ===
Version: 5

Template: Github
Owner: zgimbutas
Project: mwrap

## mwrap 1.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(mwrap LANGUAGES C CXX)

include(CTest)

option(MWRAP_ENABLE_MATLAB_CLASSDEF "Enable MATLAB classdef support (adds -DR2008OO)" OFF)
option(MWRAP_ENABLE_C99_COMPLEX "Enable C99 complex support helpers" OFF)
option(MWRAP_ENABLE_CPP_COMPLEX "Enable C++ complex support helpers" OFF)
option(MWRAP_BUILD_EXAMPLES "Build the MATLAB/Octave examples" OFF)
option(MWRAP_COMPILE_MEX "Compile generated wrappers into MEX binaries" OFF)
set(MWRAP_MEX_BACKEND "MATLAB" CACHE STRING "Select the MEX backend to use (MATLAB, OCTAVE, or ALL)")
set_property(CACHE MWRAP_MEX_BACKEND PROPERTY STRINGS MATLAB OCTAVE ALL)

set(MWRAP_MEX_BACKENDS "" CACHE INTERNAL "Resolved list of MEX backends to configure" FORCE)

unset(MWRAP_OCTAVE_MKOCTFILE_EXECUTABLE CACHE)

if(MWRAP_COMPILE_MEX)
  string(TOUPPER "${MWRAP_MEX_BACKEND}" _mwrap_mex_backend_upper)

  if(_mwrap_mex_backend_upper STREQUAL "ALL")
    set(_mwrap_resolved_backends MATLAB OCTAVE)
  elseif(_mwrap_mex_backend_upper STREQUAL "MATLAB")
    set(_mwrap_resolved_backends MATLAB)
  elseif(_mwrap_mex_backend_upper STREQUAL "OCTAVE")
    set(_mwrap_resolved_backends OCTAVE)
  else()
    message(FATAL_ERROR
      "Invalid MWRAP_MEX_BACKEND value '${MWRAP_MEX_BACKEND}'. "
      "Allowed values are MATLAB, OCTAVE, or ALL.")
  endif()

  set(MWRAP_MEX_BACKENDS "${_mwrap_resolved_backends}" CACHE INTERNAL
    "Resolved list of MEX backends to configure" FORCE)

  set(_mwrap_enable_matlab OFF)
  set(_mwrap_enable_octave OFF)
  foreach(_mwrap_backend IN LISTS _mwrap_resolved_backends)
    if(_mwrap_backend STREQUAL "MATLAB")
      set(_mwrap_enable_matlab ON)
    elseif(_mwrap_backend STREQUAL "OCTAVE")
      set(_mwrap_enable_octave ON)
    endif()
  endforeach()

  if(_mwrap_enable_matlab)
    find_package(Matlab COMPONENTS MEX_COMPILER MX_LIBRARY REQUIRED)
  endif()

  if(_mwrap_enable_octave)
    set(_mwrap_octave_mkoctfile "")
    set(_mwrap_octave_executable "")

    find_package(Octave QUIET COMPONENTS Octave_MKOCTFILE)
    if(Octave_FOUND)
      foreach(_mwrap_candidate_var IN ITEMS
          Octave_OCTAVE_MKOCTFILE_EXECUTABLE
          Octave_MKOCTFILE_EXECUTABLE
          Octave_MKOCTFILE)
        if(NOT _mwrap_octave_mkoctfile AND DEFINED ${_mwrap_candidate_var}
            AND ${_mwrap_candidate_var})
          set(_mwrap_octave_mkoctfile "${${_mwrap_candidate_var}}")
        endif()
      endforeach()

      foreach(_mwrap_candidate_var IN ITEMS
          Octave_OCTAVE_EXECUTABLE
          Octave_EXECUTABLE
          Octave_OCTAVECLI_EXECUTABLE
          Octave_OCTAVE_CLI_EXECUTABLE)
        if(NOT _mwrap_octave_executable AND DEFINED ${_mwrap_candidate_var}
            AND ${_mwrap_candidate_var})
          set(_mwrap_octave_executable "${${_mwrap_candidate_var}}")
        endif()
      endforeach()
    endif()

    if(NOT _mwrap_octave_mkoctfile)
      unset(_mwrap_octave_mkoctfile CACHE)
      unset(_mwrap_octave_mkoctfile)
      find_program(_mwrap_octave_mkoctfile mkoctfile)
    endif()

    if(NOT _mwrap_octave_mkoctfile)
      message(FATAL_ERROR
        "MWRAP_MEX_BACKEND requested Octave support but 'mkoctfile' was not found.")
    endif()

    set(MWRAP_OCTAVE_MKOCTFILE_EXECUTABLE "${_mwrap_octave_mkoctfile}" CACHE FILEPATH
      "Path to the Octave mkoctfile executable" FORCE)

    if(NOT _mwrap_octave_executable)
      unset(_mwrap_octave_executable CACHE)
      unset(_mwrap_octave_executable)
      find_program(_mwrap_octave_executable NAMES octave-cli octave)
    endif()

    if(_mwrap_octave_executable)
      set(MWRAP_OCTAVE_EXECUTABLE "${_mwrap_octave_executable}" CACHE FILEPATH
        "Path to the Octave interpreter" FORCE)
    else()
      unset(MWRAP_OCTAVE_EXECUTABLE CACHE)
    endif()
  else()
    unset(MWRAP_OCTAVE_MKOCTFILE_EXECUTABLE CACHE)
    unset(MWRAP_OCTAVE_EXECUTABLE CACHE)
  endif()
else()
  set(MWRAP_MEX_BACKENDS "" CACHE INTERNAL
    "Resolved list of MEX backends to configure" FORCE)
  unset(MWRAP_OCTAVE_MKOCTFILE_EXECUTABLE CACHE)
  unset(MWRAP_OCTAVE_EXECUTABLE CACHE)
endif()

add_subdirectory(src)

if(MWRAP_BUILD_EXAMPLES)
  add_subdirectory(example)
endif()

if(BUILD_TESTING)
  add_subdirectory(testing)
endif()

=== example/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

include(${CMAKE_SOURCE_DIR}/cmake/MwrapAddMex.cmake)

add_custom_target(mwrap_examples)

set(example_source_dir "${CMAKE_CURRENT_SOURCE_DIR}")

set(_mwrap_example_targets
  foobar
  eventq_plain
  eventq_handle
  eventq_class
  eventq2
  zlib
  fem_interface
)

set(fem_interface_support_sources
  "${example_source_dir}/fem/src/assembler.cc"
  "${example_source_dir}/fem/src/gauss2by2.cc"
  "${example_source_dir}/fem/src/mesh.cc"
  "${example_source_dir}/fem/src/quad2d1.cc"
  "${example_source_dir}/fem/src/scalar1d.cc"
  "${example_source_dir}/fem/src/scalar2d.cc"
  "${example_source_dir}/fem/src/elastic2d1.cc"
)

mwrap_add_mex(foobar
  MEX_NAME fbmex
  CC_FILENAME fbmex.cc
  M_FILENAME foobar.m
  MW_FILES "${example_source_dir}/foobar/foobar.mw"
)

mwrap_add_mex(eventq_plain
  MEX_NAME eventqpmex
  CC_FILENAME eventqpmex.cc
  MW_FILES "${example_source_dir}/eventq/eventq_plain.mw"
  MWRAP_FLAGS -mb
)

mwrap_add_mex(eventq_handle
  MEX_NAME eventqhmex
  CC_FILENAME eventqhmex.cc
  MW_FILES "${example_source_dir}/eventq/eventq_handle.mw"
  MWRAP_FLAGS -mb
  COMPILE_DEFINITIONS R2008OO
)

mwrap_add_mex(eventq_class
  MEX_NAME eventqcmex
  CC_FILENAME eventqcmex.cc
  MW_FILES "${example_source_dir}/eventq/eventq_class.mw"
  MWRAP_FLAGS -mb
  CLASSDEF_NAME eventq
)

mwrap_add_mex(eventq2
  MEX_NAME eventq2mex
  CC_FILENAME eventq2mex.cc
  MW_FILES "${example_source_dir}/eventq2/eventq2.mw"
  MWRAP_FLAGS -mb
)

mwrap_add_mex(zlib
  MEX_NAME gzmex
  CC_FILENAME gzmex.cc
  MW_FILES "${example_source_dir}/zlib/gzfile.mw"
  MWRAP_FLAGS -mb
)

mwrap_add_mex(fem_interface
  MEX_NAME femex
  CC_FILENAME femex.cc
  MW_FILES
    "${example_source_dir}/fem/interface/assembler.mw"
    "${example_source_dir}/fem/interface/mesh.mw"
    "${example_source_dir}/fem/interface/elements.mw"
  MWRAP_FLAGS -mb
  EXTRA_SOURCES ${fem_interface_support_sources}
  INCLUDE_DIRECTORIES "${example_source_dir}/fem/src"
)

foreach(example_target IN LISTS _mwrap_example_targets)
  add_dependencies(mwrap_examples ${example_target})
endforeach()

if(MWRAP_COMPILE_MEX AND MWRAP_MEX_BACKENDS)
  foreach(example_target IN LISTS _mwrap_example_targets)
    _mwrap_compile_mex(${example_target} OUTPUT_VAR _mwrap_mex_targets)

    get_target_property(_mex_output_dir ${example_target} MWRAP_OUTPUT_DIRECTORY)
    get_target_property(_mex_target_list ${example_target} MWRAP_OUTPUT_MEX_TARGETS)
    get_target_property(_mex_path_list ${example_target} MWRAP_OUTPUT_MEX_PATHS)

    if(NOT _mex_target_list OR _mex_target_list STREQUAL "NOTFOUND")
      continue()
    endif()

    if(NOT _mex_path_list OR _mex_path_list STREQUAL "NOTFOUND")
      set(_mex_path_list)
    endif()

    list(LENGTH _mex_target_list _mex_target_count)
    list(LENGTH _mex_path_list _mex_path_count)
    if(NOT _mex_target_count EQUAL _mex_path_count)
      message(FATAL_ERROR "Mismatch between recorded MEX targets and paths for ${example_target}")
    endif()

    math(EXPR _mex_index "0")
    foreach(_mex_target IN LISTS _mex_target_list)
      list(GET _mex_path_list ${_mex_index} _mex_path)
      add_dependencies(mwrap_examples ${_mex_target})

      if(_mex_output_dir AND NOT _mex_output_dir STREQUAL "NOTFOUND")
        set(_mex_should_copy TRUE)
        if(_mex_path MATCHES "\\$<TARGET_FILE:")
          set(_mex_source_path "${_mex_path}")
          set(_mex_dest_name "$<TARGET_FILE_NAME:${_mex_target}>")
          set(_mex_dest_path "${_mex_output_dir}/${_mex_dest_name}")
        else()
          set(_mex_source_path "${_mex_path}")
          if(NOT IS_ABSOLUTE "${_mex_source_path}")
            get_filename_component(_mex_source_path "${_mex_source_path}" ABSOLUTE)
          endif()
          get_filename_component(_mex_dest_name "${_mex_path}" NAME)
          set(_mex_dest_path "${_mex_output_dir}/${_mex_dest_name}")
          if(NOT IS_ABSOLUTE "${_mex_dest_path}")
            get_filename_component(_mex_dest_path "${_mex_dest_path}" ABSOLUTE)
          endif()
          if(_mex_source_path STREQUAL _mex_dest_path)
            set(_mex_should_copy FALSE)
          endif()
        endif()

        if(_mex_should_copy)
          add_custom_command(TARGET ${_mex_target} POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E make_directory "${_mex_output_dir}"
            COMMAND ${CMAKE_COMMAND} -E copy_if_different
              "${_mex_source_path}"
              "${_mex_dest_path}"
          )
        endif()
      endif()

      math(EXPR _mex_index "${_mex_index} + 1")
    endforeach()
  endforeach()
endif()

if(BUILD_TESTING AND MWRAP_COMPILE_MEX)
  if(MWRAP_MEX_BACKENDS)
    list(FIND MWRAP_MEX_BACKENDS "OCTAVE" _mwrap_octave_index)
    list(FIND MWRAP_MEX_BACKENDS "MATLAB" _mwrap_matlab_index)
  else()
    set(_mwrap_octave_index -1)
    set(_mwrap_matlab_index -1)
  endif()

  function(_mwrap_prepare_smoke_test_runner target_name runner_var workdir_var script_basename_var runner_escape_var)
    set(options)
    set(oneValueArgs SCRIPT WORKSPACE)
    set(multiValueArgs EXTRA_PATHS)
    cmake_parse_arguments(MTEST "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})

    if(NOT TARGET ${target_name})
      message(FATAL_ERROR "Unknown target '${target_name}' requested for smoke test")
    endif()

    if(NOT MTEST_SCRIPT)
      message(FATAL_ERROR "SCRIPT must be provided for smoke test on target '${target_name}'")
    endif()

    get_target_property(wrapper_dir ${target_name} MWRAP_OUTPUT_DIRECTORY)
    if(NOT wrapper_dir OR wrapper_dir STREQUAL "NOTFOUND")
      message(FATAL_ERROR "Target '${target_name}' is missing wrapper directory metadata")
    endif()

    get_target_property(classdef_dir ${target_name} MWRAP_OUTPUT_CLASSDEF_DIR)
    if(NOT classdef_dir OR classdef_dir STREQUAL "NOTFOUND")
      unset(classdef_dir)
    endif()

    set(test_paths ${MTEST_EXTRA_PATHS} "${wrapper_dir}")
    if(classdef_dir)
      list(APPEND test_paths "${classdef_dir}")
    endif()
    list(REMOVE_DUPLICATES test_paths)

    set(path_commands "")
    foreach(test_path IN LISTS test_paths)
      if(test_path)
        file(TO_CMAKE_PATH "${test_path}" test_path_cmake)
        string(REPLACE "'" "''" test_path_escaped "${test_path_cmake}")
        string(APPEND path_commands "addpath('${test_path_escaped}');\n")
      endif()
    endforeach()
    if(path_commands STREQUAL "")
      set(path_commands "% No additional paths required\n")
    endif()

    if(MTEST_WORKSPACE)
      set(work_dir "${MTEST_WORKSPACE}")
      file(MAKE_DIRECTORY "${work_dir}")
      file(TO_CMAKE_PATH "${work_dir}" work_dir_cmake)
      string(REPLACE "'" "''" work_dir_escaped "${work_dir_cmake}")
      set(work_dir_command "cd('${work_dir_escaped}');\n")
    else()
      set(work_dir "${CMAKE_CURRENT_BINARY_DIR}")
      set(work_dir_command "% No staging directory requested\n")
      file(TO_CMAKE_PATH "${work_dir}" work_dir_cmake)
    endif()

    get_filename_component(script_basename "${MTEST_SCRIPT}" NAME_WE)
    set(runner_file "${CMAKE_CURRENT_BINARY_DIR}/${script_basename}_runner.m")
    file(TO_CMAKE_PATH "${MTEST_SCRIPT}" script_path_cmake)
    string(REPLACE "'" "''" script_path_escaped "${script_path_cmake}")

    set(PATHS "${path_commands}")
    set(WORK_DIR "${work_dir_command}")
    set(CALL "${script_path_escaped}")

    configure_file(
      "${CMAKE_CURRENT_SOURCE_DIR}/run_example.m.in"
      "${runner_file}"
      @ONLY
    )

    unset(PATHS)
    unset(WORK_DIR)
    unset(CALL)

    file(TO_CMAKE_PATH "${runner_file}" runner_path_cmake)
    string(REPLACE "'" "''" runner_path_escaped "${runner_path_cmake}")

    set(${runner_var} "${runner_file}" PARENT_SCOPE)
    set(${workdir_var} "${work_dir}" PARENT_SCOPE)
    set(${script_basename_var} "${script_basename}" PARENT_SCOPE)
    set(${runner_escape_var} "${runner_path_escaped}" PARENT_SCOPE)
  endfunction()

  set(_mwrap_enable_octave_tests FALSE)
  if(_mwrap_octave_index GREATER -1 AND DEFINED MWRAP_OCTAVE_EXECUTABLE AND MWRAP_OCTAVE_EXECUTABLE)
    set(_mwrap_enable_octave_tests TRUE)
    function(_mwrap_add_octave_smoke_test target_name)
      _mwrap_prepare_smoke_test_runner(${target_name} runner_file work_dir script_basename runner_path_escaped ${ARGN})

      set(test_name "octave-${script_basename}")
      add_test(
        NAME ${test_name}
        COMMAND ${MWRAP_OCTAVE_EXECUTABLE} --no-gui --quiet --eval "run('${runner_path_escaped}')"
        WORKING_DIRECTORY "${work_dir}"
      )
    endfunction()
  endif()

  set(_mwrap_enable_matlab_tests FALSE)
  if(_mwrap_matlab_index GREATER -1 AND DEFINED Matlab_MAIN_PROGRAM AND Matlab_MAIN_PROGRAM)
    set(_mwrap_enable_matlab_tests TRUE)
    function(_mwrap_add_matlab_smoke_test target_name)
      _mwrap_prepare_smoke_test_runner(${target_name} runner_file work_dir script_basename runner_path_escaped ${ARGN})

      set(test_name "matlab-${script_basename}")
      add_test(
        NAME ${test_name}
        COMMAND "${Matlab_MAIN_PROGRAM}" -batch "run('${runner_path_escaped}')"
        WORKING_DIRECTORY "${work_dir}"
      )
    endfunction()
  endif()

  if(_mwrap_enable_octave_tests OR _mwrap_enable_matlab_tests)
    set(fem_workspace "${CMAKE_CURRENT_BINARY_DIR}/fem_workspace")
    file(MAKE_DIRECTORY "${fem_workspace}/mwfem")

    macro(_mwrap_register_example_smoke_tests add_func)
      cmake_language(CALL "${add_func}" eventq_plain
        SCRIPT "${example_source_dir}/eventq/testq_plain.m"
        EXTRA_PATHS "${example_source_dir}/eventq"
      )
      cmake_language(CALL "${add_func}" eventq_handle
        SCRIPT "${example_source_dir}/eventq/testq_handle.m"
        EXTRA_PATHS "${example_source_dir}/eventq"
      )
      cmake_language(CALL "${add_func}" eventq_class
        SCRIPT "${example_source_dir}/eventq/testq_class.m"
        EXTRA_PATHS "${example_source_dir}/eventq"
      )
      cmake_language(CALL "${add_func}" eventq2
        SCRIPT "${example_source_dir}/eventq2/testq2.m"
        EXTRA_PATHS "${example_source_dir}/eventq2"
      )
      cmake_language(CALL "${add_func}" zlib
        SCRIPT "${example_source_dir}/zlib/testgz.m"
        EXTRA_PATHS "${example_source_dir}/zlib"
      )
      cmake_language(CALL "${add_func}" fem_interface
        SCRIPT "${example_source_dir}/fem/test_simple.m"
        WORKSPACE "${fem_workspace}"
        EXTRA_PATHS "${example_source_dir}/fem" "${fem_workspace}/mwfem"
      )
      cmake_language(CALL "${add_func}" fem_interface
        SCRIPT "${example_source_dir}/fem/test_patch.m"
        WORKSPACE "${fem_workspace}"
        EXTRA_PATHS "${example_source_dir}/fem" "${fem_workspace}/mwfem"
      )
      cmake_language(CALL "${add_func}" fem_interface
        SCRIPT "${example_source_dir}/fem/test_assembler.m"
        WORKSPACE "${fem_workspace}"
        EXTRA_PATHS "${example_source_dir}/fem" "${fem_workspace}/mwfem"
      )
    endmacro()
  endif()

  if(_mwrap_enable_octave_tests)
    _mwrap_register_example_smoke_tests(_mwrap_add_octave_smoke_test)
  endif()

  if(_mwrap_enable_matlab_tests)
    _mwrap_register_example_smoke_tests(_mwrap_add_matlab_smoke_test)
  endif()
endif()

=== src/CMakeLists.txt ===
set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

add_executable(stringify stringify.c)

set(MWRAP_SUPPORT_HEADER ${CMAKE_CURRENT_BINARY_DIR}/mwrap-support.h)
add_custom_command(
  OUTPUT ${MWRAP_SUPPORT_HEADER}
  COMMAND ${CMAKE_COMMAND}
          -DSTRINGIFY=$<TARGET_FILE:stringify>
          -DINPUT=${CMAKE_CURRENT_SOURCE_DIR}/mwrap-support.c
          -DOUTPUT=${MWRAP_SUPPORT_HEADER}
          -DNAME=mex_header
          -P ${PROJECT_SOURCE_DIR}/cmake/run_stringify.cmake
  DEPENDS stringify ${CMAKE_CURRENT_SOURCE_DIR}/mwrap-support.c
  COMMENT "Generating mwrap-support.h"
  VERBATIM
)
set_source_files_properties(${MWRAP_SUPPORT_HEADER} PROPERTIES GENERATED TRUE)
add_custom_target(mwrap_support_header DEPENDS ${MWRAP_SUPPORT_HEADER})

set(MWRAP_HANDWRITTEN_SOURCES
  ${CMAKE_CURRENT_SOURCE_DIR}/mwrap-ast.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/mwrap-typecheck.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/mwrap-cgen.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/mwrap-mgen.cc
)
set(MWRAP_HANDWRITTEN_HEADERS
  ${CMAKE_CURRENT_SOURCE_DIR}/mwrap-ast.h
)

find_package(BISON REQUIRED)
find_package(FLEX REQUIRED)

if(BISON_VERSION VERSION_GREATER_EQUAL "3.0")
  set(ERROR_VERBOSE "%define parse.error verbose")
else()
  set(ERROR_VERBOSE "%error-verbose")
endif()

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/mwrap.y.in
  ${CMAKE_CURRENT_BINARY_DIR}/mwrap.y
  @ONLY
)

BISON_TARGET(MwrapParser
  ${CMAKE_CURRENT_BINARY_DIR}/mwrap.y
  ${CMAKE_CURRENT_BINARY_DIR}/mwrap.cc
  DEFINES_FILE ${CMAKE_CURRENT_BINARY_DIR}/mwrap.hh
  VERBOSE ${CMAKE_CURRENT_BINARY_DIR}/mwrap.output
)

FLEX_TARGET(MwrapLexer
  ${CMAKE_CURRENT_SOURCE_DIR}/mwrap.l
  ${CMAKE_CURRENT_BINARY_DIR}/lex.yy.c
)

ADD_FLEX_BISON_DEPENDENCY(MwrapLexer MwrapParser)

set(MWRAP_GENERATED_SOURCES
  ${BISON_MwrapParser_OUTPUT_SOURCE}
  ${FLEX_MwrapLexer_OUTPUTS}
)
set(MWRAP_GENERATED_HEADERS
  ${BISON_MwrapParser_OUTPUT_HEADER}
)
set_source_files_properties(${MWRAP_GENERATED_SOURCES} ${MWRAP_GENERATED_HEADERS} PROPERTIES GENERATED TRUE)

add_executable(mwrap
  ${MWRAP_HANDWRITTEN_SOURCES}
  ${MWRAP_GENERATED_SOURCES}
  ${MWRAP_SUPPORT_HEADER}
)
add_dependencies(mwrap mwrap_support_header)

target_sources(mwrap PRIVATE ${MWRAP_HANDWRITTEN_HEADERS} ${MWRAP_GENERATED_HEADERS})

target_include_directories(mwrap PRIVATE
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
)

target_compile_definitions(mwrap PRIVATE
  $<$<BOOL:${MWRAP_ENABLE_MATLAB_CLASSDEF}>:R2008OO>
  $<$<BOOL:${MWRAP_ENABLE_C99_COMPLEX}>:MWRAP_ENABLE_C99_COMPLEX>
  $<$<BOOL:${MWRAP_ENABLE_CPP_COMPLEX}>:MWRAP_ENABLE_CPP_COMPLEX>
)

install(TARGETS mwrap RUNTIME DESTINATION bin)

=== testing/Makefile ===
--- 
+++ 
@@ -103,6 +103,12 @@
 test_gpu_int32:
 	../mwrap -gpu -list -cppcomplex -mb -mex test_gpu_int32 -c test_gpu_int32.cu test_gpu_int32.mw
 
+# GPU tests: requires CUDA toolkit and GPU device
+# Run mwrap targets first (test_gpu, test_gpu_complex, test_gpu_int32),
+# then run this target from MATLAB/Octave with GPU support.
+test_all_gpu: test_gpu test_gpu_complex test_gpu_int32
+	matlab -batch "test_all_gpu"
+
 test_cpu:
 	../mwrap -list -cppcomplex -mb -mex test_cpu -c test_cpu.cc test_cpu.mw
 
@@ -110,8 +116,9 @@
 	../mwrap -list -cppcomplex -mb -mex test_cpu_int32 -c test_cpu_int32.cc test_cpu_int32.mw
 
 clean:
-	rm -f *~ *.mex* *.o* test_typecheck.log
+	rm -f *~ *.mex* *.o* test_typecheck.log test_syntax.log
 	rm -f test_fortran1.m test_fortran2.m test_transfers.m test_catch.m
+	rm -f test_fortran1mex.cc test_fortran2mex.c
 	rm -f test_cpp_complex.m test_c99_complex.m
 	rm -f test_transfersmex.cc test_catchmex.cc test_fortranmex.cc
 	rm -f test_cpp_complexmex.cc test_c99_complexmex.c 
@@ -119,5 +126,8 @@
 	rm -f test_singlemex.c test_singlemex.cc
 	rm -f add.m addf.m addz.m addc.m 
 	rm -f arradd.m arraddf.m arraddz.m arraddc.m 
+	rm -f test_include.m test_includemex.cc
 	rm -f test_charmex.c test_charmex.cc
-	rm -f addchar.m arraddchar.m 
+	rm -f addchar.m arraddchar.m
+	rm -f test_cpu.cc timestwo_cpu.m
+	rm -f test_cpu_int32.cc timestwo_cpu_int32.m

=== example/zlib/Makefile ===
# See www.zlib.net
include ../../make.inc
MW=../../mwrap

gzmex:
	$(MW) -mex gzmex -mb gzfile.mw
	$(MW) -mex gzmex -c gzmex.cc gzfile.mw
	$(MEX) gzmex.cc -lz

clean:
	rm -f gz*.m gzmex.* *.o* eye.gz

=== debian/changelog ===
mwrap (1.3-1) unstable; urgency=medium

  * New upstream version 1.3
  * d/copyright: Reflect upstream changes
  * d/p/allow-alternate-mwrap-in-tests.patch: Refresh for new upstream version
  * d/p/force-doc-date.patch: Refresh for new upstream version
  * d/docs: Include README.md file
  * d/control:
    + Drop the redundant Priority field, which defaults to optional now
    + Bump Standards-Version to 4.7.3
  * d/control: Update Homepage
  * d/salsa-ci.yml: Add CI pipeline

 -- Rafael Laboissière <rafael@debian.org>  Thu, 26 Feb 2026 09:53:16 +0000

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: mwrap
 Section: devel
-Priority: optional
 Maintainer: Debian Octave Group <team+pkg-octave-team@tracker.debian.org>
 Uploaders: Nicolas Bourdaud <nicolas.bourdaud@gmail.com>,
            Rafael Laboissière <rafael@debian.org>
@@ -9,8 +8,8 @@
                flex,
                latexmk,
                octave-dev
-Standards-Version: 4.7.2
-Homepage: https://www.cs.cornell.edu/~bindel/blurbs/mwrap.html
+Standards-Version: 4.7.3
+Homepage: https://github.com/zgimbutas/mwrap
 Vcs-Browser: https://salsa.debian.org/pkg-octave-team/mwrap
 Vcs-Git: https://salsa.debian.org/pkg-octave-team/mwrap.git
